.586
.model flat,stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\shell32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\shell32.lib

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
EnumProc    PROTO   :DWORD,:DWORD

.const

MainWindowWidth     equ 600
MainWindowHeight    equ 350
ID_WNDMOVER         equ 200h
USRM_RESTORE        equ 0f0000h
.data
hInstance   dd      ?
hDesktop    dd      ?

MainWindowClass db  'MainWindowClass',0
MainWindowName  db  'Window Mover',0
hMainWindow     dd      ?
hIcon        dd      ?
nid             NOTIFYICONDATA      <sizeof nid,?,ID_WNDMOVER,NIF_ICON+NIF_MESSAGE+NIF_TIP,WM_USER+1,?,\
                                    'Window Mover'>
rect        RECT        <>
hWin        dd          ?   
WindowHandles   dd  500000 dup(0)
lpWindowHandles dd  offset WindowHandles
NoWindows       dd      0   

ListBoxClass    db  'LISTBOX',0
hListBox        dd      ?
TempBuffer      db      512 dup(0)
cnt             dd      0
                              
.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   wc:WNDCLASSEX
    local   msg:MSG

    mov     wc.cbSize,sizeof wc
    mov     wc.style,CS_HREDRAW+CS_VREDRAW
    mov     wc.lpfnWndProc,offset WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,offset MainWindowClass
    mov     wc.hbrBackground,COLOR_WINDOW
    push    hInst
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    mov     hIcon,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_OVERLAPPEDWINDOW,\ 
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInst,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,SW_HIDE
    invoke  UpdateWindow,hMainWindow
msg_loop:
 ;     invoke  PeekMessage,addr msg,0,0,0,PM_NOREMOVE
 ;     or      eax,eax
 ;     jz      no_msg  
    invoke  GetMessage,addr msg,NULL,0,0
    cmp     eax,NULL
    je      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
no_msg:
    mov     ecx,NoWindows
    mov     esi,lpWindowHandles
move_loop:    
    lodsw
    mov     hWin,eax
    push    ecx
    invoke  GetWindowRect,eax,addr rect
    inc     rect.left
    inc     rect.top
    invoke  MoveWindow,hWin,rect.left,rect.top,rect.right,rect.bottom,TRUE
    pop     ecx
    dec     ecx
    cmp     ecx,0
    je      msg_loop
    jmp     move_loop        
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain endp                

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD


    
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov edi,lParam
        .if [edi.CREATESTRUCT].hWndParent==NULL
            mov nid.cbSize,sizeof nid
            mov nid.uFlags,NIF_ICON+NIF_MESSAGE+NIF_TIP
            push    hWnd
            pop     nid.hwnd
            push    hIcon
            pop     nid.hIcon
            invoke  Shell_NotifyIcon,NIM_ADD,addr nid
            invoke  GetClientRect,hWnd,addr rect
            invoke  CreateWindowEx,WS_EX_STATICEDGE,addr ListBoxClass,NULL,WS_VISIBLE+WS_CHILD\
                        +LBS_HASSTRINGS+WS_VSCROLL,0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
            mov hListBox,eax                        
            invoke  EnumWindows,addr EnumProc,NULL
            mov     lpWindowHandles,offset WindowHandles

        .endif            
    .elseif uMsg==WM_USER+1
        .if wParam==ID_WNDMOVER
            .if lParam==WM_LBUTTONDBLCLK
                invoke  SendMessage,hWnd,WM_COMMAND,USRM_RESTORE+ID_WNDMOVER,NULL  
            .endif
        .endif
    .elseif uMsg==WM_COMMAND
        mov eax,wParam
        .if ax==ID_WNDMOVER
            invoke  Beep,200,20
            ror eax,16
            .if ax==USRM_RESTORE
                invoke  Beep,400,20
                invoke  Shell_NotifyIcon,NIM_DELETE,addr nid
                invoke  ShowWindow,hWnd,SW_RESTORE
            .endif
        .endif                                                                      
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret
                            
WndProc endp

EnumProc    PROC   uses edi hWnd:DWORD,Arg:DWORD


    .if hWnd!=NULL
    mov edi,lpWindowHandles
    invoke  GetWindowText,hWnd,addr TempBuffer,512
    invoke  SendMessage,hListBox,LB_ADDSTRING,NULL,addr TempBuffer
    mov eax,hWnd
    cld
    stosd
    inc NoWindows
    mov eax,TRUE
    mov lpWindowHandles,edi
    mov eax,TRUE
    ret
    .else
ret_false:    
    mov eax,FALSE
    ret
    .endif
    
EnumProc    endp

end start